/*
 * _gen/svc-OLPC_Activity_Properties.c - Source for GabbleSvcOLPCActivityProperties
 *
 *  Copyright (C) 2007 Collabora Limited 
 *
 * This file may be distributed under the same terms as the specification
 * from which it is generated.
 */

#include "_gen/svc-OLPC_Activity_Properties.h"

#include <stdio.h>
#include <stdlib.h>

#include <telepathy-glib/dbus.h>
#include "signals-marshal.h"

const DBusGObjectInfo dbus_glib_gabble_svc_olpc_activity_properties_object_info;
struct _GabbleSvcOLPCActivityPropertiesClass {
    GTypeInterface parent_class;
    gabble_svc_olpc_activity_properties_get_properties_impl get_properties;
    gabble_svc_olpc_activity_properties_set_properties_impl set_properties;
};

enum {
    SIGNAL_ActivityPropertiesChanged,
    N_SIGNALS
};
static guint signals[N_SIGNALS] = {0};


static void
gabble_svc_olpc_activity_properties_base_init (gpointer klass)
{
  static gboolean initialized = FALSE;

  if (!initialized)
    {
      initialized = TRUE;

      signals[SIGNAL_ActivityPropertiesChanged] =
      g_signal_new ("activity-properties-changed",
                    G_OBJECT_CLASS_TYPE (klass),
                    G_SIGNAL_RUN_LAST | G_SIGNAL_DETAILED,
                    0,
                    NULL, NULL,
                    _gabble_ext_marshal_VOID__UINT_BOXED,
                    G_TYPE_NONE, 2, G_TYPE_UINT, (dbus_g_type_get_map ("GHashTable", G_TYPE_STRING, G_TYPE_VALUE)));

      dbus_g_object_type_install_info (gabble_svc_olpc_activity_properties_get_type (), &dbus_glib_gabble_svc_olpc_activity_properties_object_info);
    }
}

GType
gabble_svc_olpc_activity_properties_get_type (void)
{
  static GType type = 0;

  if (G_UNLIKELY (type == 0)) {
    static const GTypeInfo info = {
      sizeof (GabbleSvcOLPCActivityPropertiesClass),
      gabble_svc_olpc_activity_properties_base_init, /* base_init */
      NULL, /* base_finalize */
      NULL, /* class_init */
      NULL, /* class_finalize */
      NULL, /* class_data */
      0,
      0, /* n_preallocs */
      NULL /* instance_init */
    };

    type = g_type_register_static (G_TYPE_INTERFACE, "GabbleSvcOLPCActivityProperties", &info, 0);
  }

  return type;
}


/**
 * gabble_svc_olpc_activity_properties_get_properties_impl
 * @self: The object implementing this interface
 * @room: FIXME: document args in genginterface
 * @context: The D-Bus invocation context to use to return values
 *           or throw an error.
 *
 * Signature of an implementation of D-Bus method GetProperties
 * on interface org.laptop.Telepathy.ActivityProperties
 */
static void
gabble_svc_olpc_activity_properties_get_properties (GabbleSvcOLPCActivityProperties *self,
                                                    guint room,
                                                    DBusGMethodInvocation *context)
{
  gabble_svc_olpc_activity_properties_get_properties_impl impl = (GABBLE_SVC_OLPC_ACTIVITY_PROPERTIES_GET_CLASS (self)->get_properties);
  if (impl)
    (impl) (self, room, context);
  else
    tp_dbus_g_method_return_not_implemented (context);
}

/**
 * gabble_svc_olpc_activity_properties_implement_get_properties:
 * @klass: A class whose instances implement this interface
 * @impl: A callback used to implement the GetProperties method
 *
 * Register an implementation for the GetProperties method in the vtable of an
 * implementation of this interface. To be called from the interface
 * init function.
 */
void
gabble_svc_olpc_activity_properties_implement_get_properties (GabbleSvcOLPCActivityPropertiesClass *klass, gabble_svc_olpc_activity_properties_get_properties_impl impl)
{
  klass->get_properties = impl;
}


/**
 * gabble_svc_olpc_activity_properties_set_properties_impl
 * @self: The object implementing this interface
 * @room: FIXME: document args in genginterface
 * @properties: FIXME: document args in genginterface
 * @context: The D-Bus invocation context to use to return values
 *           or throw an error.
 *
 * Signature of an implementation of D-Bus method SetProperties
 * on interface org.laptop.Telepathy.ActivityProperties
 */
static void
gabble_svc_olpc_activity_properties_set_properties (GabbleSvcOLPCActivityProperties *self,
                                                    guint room,
                                                    GHashTable *properties,
                                                    DBusGMethodInvocation *context)
{
  gabble_svc_olpc_activity_properties_set_properties_impl impl = (GABBLE_SVC_OLPC_ACTIVITY_PROPERTIES_GET_CLASS (self)->set_properties);
  if (impl)
    (impl) (self, room, properties, context);
  else
    tp_dbus_g_method_return_not_implemented (context);
}

/**
 * gabble_svc_olpc_activity_properties_implement_set_properties:
 * @klass: A class whose instances implement this interface
 * @impl: A callback used to implement the SetProperties method
 *
 * Register an implementation for the SetProperties method in the vtable of an
 * implementation of this interface. To be called from the interface
 * init function.
 */
void
gabble_svc_olpc_activity_properties_implement_set_properties (GabbleSvcOLPCActivityPropertiesClass *klass, gabble_svc_olpc_activity_properties_set_properties_impl impl)
{
  klass->set_properties = impl;
}

/**
 * gabble_svc_olpc_activity_properties_emit_activity_properties_changed:
 * @instance: An object implementing this interface
 * @room: FIXME: document args in genginterface
 * @properties: FIXME: document args in genginterface
 *
 * Emit the ActivityPropertiesChanged D-Bus signal from @instance with the given arguments.
 */
void gabble_svc_olpc_activity_properties_emit_activity_properties_changed (gpointer instance,
    const guint  room,
    const GHashTable * properties)
{
  g_assert (GABBLE_IS_SVC_OLPC_ACTIVITY_PROPERTIES (instance));
  g_signal_emit (instance, signals[SIGNAL_ActivityPropertiesChanged], 0, room, properties);
}

#include "_gen/svc-OLPC_Activity_Properties-glue.h"

